
#include "SATCollision.h"

#include "CameraFollowSystem.h"
#include "Entity.h"
#include "TransformableComponent.h"
#include "AnimManager.h"
#include "Constants.h"
#include "Utility.h"

CameraFollowSystem::CameraFollowSystem()
{
	addComponentType<TransformableComponent>();
}

void CameraFollowSystem::initialize()
{
	transformableMapper.init(*world);
}

void CameraFollowSystem::processEntities(artemis::ImmutableBag<artemis::Entity*>& entities)
{
	artemis::Entity& camera = world->getTagManager()->getEntity(constants::cameraTag);
	artemis::Entity& player = world->getTagManager()->getEntity(constants::playerTag);
	std::shared_ptr<sf::Transformable> cameraTransform = camera.getComponent<TransformableComponent>()->transformable;
	std::shared_ptr<sf::Transformable> playerTransform = player.getComponent<TransformableComponent>()->transformable;

	cameraTransform->setOrigin(400, 500);
	cameraTransform->setPosition(playerTransform->getPosition());
	cameraTransform->setRotation(playerTransform->getRotation() + 90);
}

bool CameraFollowSystem::checkProcessing()
{
	return true;
}