
#ifndef __ENTITYFACTORY_H
#define __ENTITYFACTORY_H

#include "World.h"
#include "Entity.h"

#include "TextureManager.h"

#include <memory>

class EntityFactory
{
public:
	static artemis::Entity& CreateBeam(artemis::World& world, const sf::Vector2f& pos,
										   const sf::Vector2f& pointPos);
	static artemis::Entity& CreateStaticTest(artemis::World& world, const sf::Vector2f& pos);
	static artemis::Entity& CreateExplosion(artemis::World& world, const sf::Vector2f& pos);
	static artemis::Entity& CreateStatic(artemis::World& world, const sf::Vector2f& pos, std::string imgLoc);
	static artemis::Entity& CreateCamera(artemis::World& world, const sf::Vector2f& pos);
	static artemis::Entity& CreateBullet(artemis::World& world, const sf::Vector2f& relPos);

	//Singletons
	static artemis::Entity& CreatePlayer(artemis::World& world, const sf::Vector2f& pos);
	static artemis::Entity& CreateRootNode(artemis::World& world);
private:
	static std::shared_ptr<artemis::Entity> rootNode;
	static std::shared_ptr<artemis::Entity> player;
};

#endif