
#ifndef __PARTICLECOMPONENT_H
#define __PARTICLECOMPONENT_H

#include "Component.h"

#include <SFML\Graphics.hpp>

#include "Particles.h"

class ParticleComponent : public artemis::Component
{
public:
	ParticleComponent(int numParticles, float velocity, float velocityVariance,
		float angle, float angleVariance, float lifetime, float lifetimeVariance,
		float age, float ageVariance, float size, float sizeVariance,
		float offset, float offsetVariance, const sf::Texture& particleTexture) :
			particles(numParticles) ,
			particleTexture(particleTexture)
	{
		this->velocity = velocity;
		this->velocityVariance = velocityVariance;
		this->angle = angle;
		this->angleVariance = angleVariance;
		this->lifetime = lifetime;
		this->lifetimeVariance = lifetimeVariance;
		this->size = size;
		this->sizeVariance = sizeVariance;

		this->numParticles = numParticles;
	}

	int numParticles;
	float velocity;
	float velocityVariance;
	float angle;
	float angleVariance;
	float lifetime;
	float lifetimeVariance;
	float age;
	float ageVariance;
	float size;
	float sizeVariance;
	float offset;
	float offsetVariance;

	enum {
		radial, line
	} type;

	Particles particles;
	const sf::Texture& particleTexture;
};

#endif