
#include "ParticleSystem.h"

#include "ParticleComponent.h"
#include "TransformableComponent.h"

ParticleSystem::ParticleSystem()
{
	addComponentType<ParticleComponent>();
	addComponentType<TransformableComponent>();
}

void ParticleSystem::initialize()
{
	particleMapper.init(*world);
	transformableMapper.init(*world);
}

void ParticleSystem::processEntity(artemis::Entity &e)
{
	ParticleComponent* particleComponent = particleMapper.get(e);
	Particles& particles = particleComponent->particles;

	for(int i = 0; i < particleComponent->numParticles; i++) {
		particles.ages[i] += sf::seconds(world->getDelta());
		//Advance the particle position
		sf::Vector2f newPos = particles.particles[i].getPosition();
		newPos.x += particleComponent->velocity * cos(particleComponent->angle*TO_DEG);
		newPos.y += particleComponent->velocity * sin(particleComponent->angle*TO_DEG);
	}
}