
#ifndef __RENDERSYSTEM_H
#define __RENDERSYSTEM_H

#include "EntityProcessingSystem.h"
#include "ComponentMapper.h"

class TransformableComponent;
class RenderComponent;

#include "SFML/Graphics.hpp"
#include <memory>

class RenderSystem : public artemis::EntitySystem {
private:
	artemis::ComponentMapper<TransformableComponent> TransformableMapper;
    artemis::ComponentMapper<RenderComponent> RenderMapper;
	sf::RenderWindow& window;

public:
    RenderSystem(sf::RenderWindow& window);

    virtual void initialize();

	virtual void processEntities(artemis::ImmutableBag<artemis::Entity*> & entities);
	virtual bool checkProcessing();
};

#endif