
#include "TextureManager.h"

std::map<std::string, sf::Texture> TextureManager::textures;
std::list<std::unique_ptr<sf::RenderTexture>> TextureManager::renderTextures;

sf::Texture& TextureManager::GetTexture(const std::string& path)
{
	textureIterator iter = textures.find(path);
	if(iter != textures.end()) {
		return iter->second;
	} else {
		textures[path] = sf::Texture();
		textures[path].loadFromFile(path);
		return textures[path];
	}
}

sf::RenderTexture& TextureManager::CreateRenderTexture() {
	renderTextures.push_back(std::unique_ptr<sf::RenderTexture>(new sf::RenderTexture()));
	return *renderTextures.back();
}