

#ifndef __TEXTUREMANAGER_H
#define __TEXTUREMANAGER_H

#include <map>
#include <list>
#include <memory>

#include "SFML/Graphics.hpp"

class TextureManager
{
public:
	static sf::Texture& GetTexture(const std::string& path);
	static sf::RenderTexture& CreateRenderTexture();

private:
	typedef std::map<std::string, sf::Texture>::iterator textureIterator;
	static std::map<std::string, sf::Texture> textures;
	static std::list<std::unique_ptr<sf::RenderTexture>> renderTextures;
};

#endif